// GFTPTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "GFTPTest.h"
#include "GFTPTestDlg.h"
#include "FTPclient.h"






#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGFTPTestDlg dialog

CGFTPTestDlg::CGFTPTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CGFTPTestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CGFTPTestDlg)
	m_host = _T("");
	m_user = _T("");
	m_pass = _T("");
	m_port = 21;
	m_fwhost = _T("");
	m_fwport = 21;
	m_fwuser = _T("");
	m_fwpass = _T("");
	m_lfile = _T("");
	m_rfile = _T("");
	m_pasv = FALSE;
	m_put = 0;
	m_logontype = 0;
	m_acct = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CGFTPTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CGFTPTestDlg)
	DDX_Text(pDX, IDC_EDIT1, m_host);
	DDX_Text(pDX, IDC_EDIT2, m_user);
	DDX_Text(pDX, IDC_EDIT3, m_pass);
	DDX_Text(pDX, IDC_EDIT4, m_port);
	DDX_Text(pDX, IDC_EDIT5, m_fwhost);
	DDX_Text(pDX, IDC_EDIT6, m_fwport);
	DDX_Text(pDX, IDC_EDIT7, m_fwuser);
	DDX_Text(pDX, IDC_EDIT8, m_fwpass);
	DDX_Text(pDX, IDC_EDIT9, m_lfile);
	DDX_Text(pDX, IDC_EDIT10, m_rfile);
	DDX_Check(pDX, IDC_CHECK1, m_pasv);
	DDX_Radio(pDX, IDC_RADIO1, m_put);
	DDX_Radio(pDX, IDC_RADIO3, m_logontype);
	DDX_Text(pDX, IDC_EDIT11, m_acct);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CGFTPTestDlg, CDialog)
	//{{AFX_MSG_MAP(CGFTPTestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
	ON_CONTROL_RANGE(BN_CLICKED,IDC_RADIO3,IDC_RADIO11,OnRadio)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGFTPTestDlg message handlers

BOOL CGFTPTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CGFTPTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CGFTPTestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CGFTPTestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}



// hide/show firewall edit ctrls as appropriate
void CGFTPTestDlg::OnRadio(UINT nID) {
	UpdateData(TRUE);
	for(int i=IDC_EDIT5;i<=IDC_EDIT8;i++)
		GetDlgItem(i)->EnableWindow(m_logontype);
}




void CGFTPTestDlg::OnButton1() 
{
	CFTPclient ftp;

	UpdateData(TRUE);

	// connect to FTP server
	if(!ftp.LogOnToServer(m_host,m_port,m_user,m_pass,m_acct,m_fwhost,m_fwuser,m_fwpass,m_fwport,m_logontype)) {
		MessageBox(ftp.m_retmsg);
		return;
	}

	// move a file by FTP
	ftp.MoveFile(m_lfile,m_rfile,m_pasv,m_put);

	// show the result of the operation
	MessageBox(ftp.m_retmsg);

	// disconnect from server
	ftp.LogOffServer();
}

